<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
  </head>
  <body>
    <script>
      /*
        1. Сделайте класс Product (товар), в котором будут приватные свойства name
        (название товара), price (цена за штуку) и quantity.
        Пусть все эти свойства будут доступны только для чтения.
      2. Добавьте в класс Product метод getCost, который будет находить полную стоимость продукта
        (сумма умножить на количество).
      3. Сделайте класс Cart (корзина). Данный класс будет хранить список продуктов
        (объектов класса Product) в виде массива. Пусть продукты хранятся в свойстве products.
      4. Реализуйте в классе Cart метод add для добавления продуктов.
      5. Реализуйте в классе Cart метод remove для удаления продуктов.
        Метод должен принимать параметром название удаляемого продукта.
      6. Реализуйте в классе Cart метод getTotalCost, который будет находить суммарную стоимость
          продуктов.
      7. Реализуйте в классе Cart метод getTotalQuantity,
        который будет находить суммарное количество продуктов
        (то есть сумму свойств quantity всех продуктов).
      8.  Реализуйте в классе Cart метод getAvgPrice,
        который будет находить среднюю стоимость продуктов
        (суммарная стоимость делить на количество всех продуктов).
        */

        class Product {
          #name;
          #price;
          #quantity;
          constructor (name, price, quantity) {
            this.#name = name;
            this.#price = price;
            this.#quantity = quantity;
          }
          get name() {
            return this.#name = name;
          }
          get quantity () {
            return this.#quantity = quantity;
          }
          get cost() {
            return this.#price * this.#quantity;
          }
        }
        
        class Cart {
          constructor (products) {
            this.products = products;
          }
          add (products) {
            this.products.push(products);
          }
          remove (nameProduct) {
            this.products = this.products.filter((elem) => elem.name !== nameProduct);
          }
          getTotalCost () {
            let sum = 0;
            this.products.forEach((element) => {
              sum += element.cost;
            });
            return sum;
          }
          getTotalQuantity () {
            let count = 0;
            this.products.forEach((element) => {
              count += element.quantity
            });
            return count;
          }
          getAvgPrice () {
            return this.getTotalCost()/this.getTotalQuantity();
          }
        }

        const mouse = new Product('mouse', 50, 10);
        const cat = new Product('cat', 50, 10);
        const newCart = new Cart([mouse, cat]);
      console.log(newCart.getAvgPrice());
    </script>
  </body>
</html>
